package u8c.bs.mytest.bp;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.pub.BusinessException;
import u8c.pubitf.rule.IRule;
import u8c.vo.AggDemandVO;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;

public class ValidateRule implements IRule<AggDemandVO> {

	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	/**
	 * У
	 */
	@Override
	public void process(AggDemandVO[] vos) throws BusinessException {
		for(int i = 0; i < vos.length; i++) {
			DemandVO demandVO = (DemandVO) vos[i].getParentVO();
			DemandBVO[] demandBVOs = (DemandBVO[]) vos[i].getChildrenVO();
			for (int j = 0; j < demandBVOs.length; j++) {
				getDefdoc("HJϽ",demandBVOs[j].getAlloy());
				getDefdoc("BZ׼",demandBVOs[j].getStandard());
				getMeasdoc(demandBVOs[j].getCastunitid());
			}
		}
	}
	
	
	//ѯԶ嵵
    public  void getDefdoc(String doclistcode,String docname) throws BusinessException {
    	if(docname == null) {
    		return ;
    	}
        String sql = "select pk_defdoc from bd_defdoc where pk_defdoclist = (select pk_defdoclist from bd_defdoclist where doclistcode = '"+doclistcode+"') and docname ='"+docname+"'";
        String pk_defdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_defdoc == null) {
        	throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1 Զ嵵ƣ"+docname+"");
        }
    }
    
    //ѯ
    public  void getMeasdoc(String shortname) throws BusinessException {
    	if(shortname == null) {
    		return ;
    	}
        String sql = "select pk_measdoc from bd_measdoc where measname ='"+shortname+"'";
        String pk_measdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_measdoc == null) {
        	throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1 ƣ"+shortname+"");
        }
    }
    

}
